{X$H-}
{   |/~~|\
    /|  |/   |
    ||  \    /~\  /~~\ /~~ /~~\
    /|  | \  |_/  \__\ __/ \__

    RBASE IS SMALL, LIGHT WEIGHT DATABASE SYSTEM FOR PASCAL
    YUP IT IS MY OWN FORMAT
    RBASE IS RYAN_DATABASE
    RYAN2000 END OF YEAR

    THIS IS DELPHI VERSION !!!!!!!
    AND I THINK THIS IS VIRTUAL PASCAL VERSION TOO !!!! :)
}

unit rbase;

INTERFACE
USES RSTR,DOS;

type    DWORD=LONGINT;
        Theader=packed record
                   RBASEID1     :LONGINT;
                   RBASEID2     :STRING[20];
                   RECORDS      :ARRAY[0..20] OF LONGINT;
                   FIELD        :ARRAY[0..20] OF STRING[15];
                   FIELDTYPE    :ARRAY[0..20] OF CHAR;
                   FIELDLEN     :ARRAY[0..20] OF BYTE;
                   FIELDDEC     :ARRAY[0..20] OF BYTE;
                   FIELDCOUNT   :WORD;
                   RECORDLEN    :WORD;
                   RECORDCOUNT  :LONGINT;
                   UPDATES      :ARRAY[0..1000] OF BYTE;
             END;

     TFILTERPROC =FUNCTION:BOOLEAN;
     TINDEXS     =ARRAY[0..20000] OF BYTE; { to handle 160000 records }
     DBERRORS    =(DBE_NOERROR,DBE_NOTVALIDRECORD,DBE_ENDOFRECORD);
     RREAL       =SINGLE;

     TRbase=object

{         PUBLIC}
            OPENED      :BOOLEAN;
            Buffer      :Array[0..1000] of byte;
            Header      :Theader;
            DBHANDLE    :FILE;
            FILENAME    :STRING;
            FILTER      :BOOLEAN;
            FILTERPROC  :TFILTERPROC;
            FOUND       :BOOLEAN;
            INDEXS      :^TINDEXS;
            RECORDFOUND :LONGINT;
            CURRENTREC  :LONGINT;
            PHYSICREC   :LONGINT;
            DBER        :DBERRORS;
            RA          :^STRING;
            RB          :^LONGINT;
            RC          :^RREAL;
            RD          :^LONGINT;



            PROCEDURE OPENDB;
            PROCEDURE CLOSEDB;
            FUNCTION  FIELDGET(FNAME:STRING):STRING;
            FUNCTION  NUMBERGET(FNAME:STRING):RREAL;
            FUNCTION  LONGINTGET(FNAME:STRING):LONGINT;

            PROCEDURE LONGINTPUT(FNAME:STRING;ITEM:LONGINT);
            PROCEDURE NUMBERPUT(FNAME:STRING;ITEM:RREAL);
            PROCEDURE FIELDPUT(FNAME,ITEM:STRING);
            FUNCTION  FIELDNO(FNAME:STRING):INTEGER;

            FUNCTION  FIELDNOGET(FNAME:INTEGER):STRING;
            PROCEDURE FIELDNOPUT(FNAME:INTEGER;ITEM:STRING);

            PROCEDURE FIND(FIELD,WHAT:STRING);

            PROCEDURE APPEND;
            PROCEDURE REPLACE;
            PROCEDURE CLEARBUFFER;
            PROCEDURE SKIP(I:LONGINT);
            PROCEDURE GO(I:LONGINT);
            PROCEDURE FILTERUSE(A:TFILTERPROC);
            PROCEDURE REFILTER;
            PROCEDURE UNFILTER;
            PROCEDURE GOTOP;

{         PRIVATE}

            PROCEDURE SETINDEX(N:LONGINT);
            PROCEDURE UNSETINDEX(N:LONGINT);
            FUNCTION  ISINDEX(N:LONGINT):BOOLEAN;

            PROCEDURE READRECORD(I:LONGINT);
            PROCEDURE WRITERECORD(I:LONGINT);

            PROCEDURE IGO(I:LONGINT);
            PROCEDURE PGO(I:LONGINT);
            PROCEDURE ISKIP(I:LONGINT);
            PROCEDURE PSKIP(I:LONGINT);





     END;

VAR CREATE_HEADER       :THEADER;
    CREATE_HANDLE       :FILE;

    DBOBJ               :ARRAY[0..20] OF TRBASE;
    INDEX               :ARRAY[0..20] OF STRING;
    DBACTIVE         :^TRBASE;

    DBSELECT            :INTEGER;



    PROCEDURE CREATE(FILENAME:STRING);
    PROCEDURE ADDFIELD(FNAME:STRING;FTYPE:CHAR;FLEN,FDEC:BYTE);
    PROCEDURE DONE;
    FUNCTION DEOF:BOOLEAN;
    FUNCTION NUMBERGET(A:STRING):RREAL;
    PROCEDURE NUMBERPUT(A:STRING;B:RREAL);
    FUNCTION FIELDGET(A:STRING):STRING;
    PROCEDURE STRINGPUT(A,B:STRING);
    PROCEDURE INDEXON(A,N:STRING);
    PROCEDURE UNFILTER;
    PROCEDURE GOTOP;
    PROCEDURE SETFILTERTHRU(A:TFILTERPROC);
    PROCEDURE GO(N:LONGINT);
    PROCEDURE SKIP(N:LONGINT);
    PROCEDURE FIND(N:STRING);
    PROCEDURE CLOSEDATABASES;
    PROCEDURE USE(N:STRING);
    PROCEDURE SELECT(N:BYTE);
    FUNCTION FOUND:BOOLEAN;
    FUNCTION RECORDFOUND:INTEGER;
    PROCEDURE APPEND;
    PROCEDURE REPLACE;
    FUNCTION FIELDDEC(I:INTEGER):BYTE;
    FUNCTION FIELDLEN(I:INTEGER):BYTE;
    PROCEDURE REFILTER;
    FUNCTION FIELDTYPE(I:INTEGER):CHAR;
    FUNCTION FIELD(I:INTEGER):STRING;
    FUNCTION FIELDCOUNT:INTEGER;
    PROCEDURE CLEARRECORD;
    FUNCTION FILEEXIST(N:STRING):BOOLEAN;
    FUNCTION DATE:LONGINT;
    FUNCTION DTOC(L:LONGINT):STRING;
    FUNCTION CTOD(S:STRING):LONGINT;
    PROCEDURE DATEPUT(A:STRING;B:LONGINT);
    FUNCTION DATEGET(A:STRING):LONGINT;

IMPLEMENTATION

     {$I-}
PROCEDURE UNPACKTIME(L:LONGINT;VAR D:RDATE);
BEGIN
        D.YEAR:=L SHR 9;
        D.MONTH:=(L SHR 5) AND 15;
        D.DAY:=L AND 31;
END;
PROCEDURE PACKTIME(D:RDATE;VAR L:LONGINT);
BEGIN
        L:=0;
        L:=L OR (D.YEAR SHL 9);
        L:=L OR (D.MONTH SHL 5);
        L:=L OR (D.DAY);
END;
FUNCTION DTOC(L:LONGINT):STRING;
VAR D:RDATE;
BEGIN
     UNPACKTIME(L,D);
     DTOC:=RSTR.DATETOSTR(D);
END;

FUNCTION CTOD(S:STRING):LONGINT;
VAR D:RDATE;
    L:LONGINT;
BEGIN
     RSTR.STRTODATE(S,D);
     PACKTIME(D,L);
     CTOD:=L;
END;

FUNCTION DATE:LONGINT;
VAR D:RDATE;
    C:WORD;
    L:LONGINT;
BEGIN
     GETCURRDATE(D);
     PACKTIME(D,L);
     DATE:=L;
END;


FUNCTION FILTERDUMMY:BOOLEAN;
BEGIN
END;

PROCEDURE CREATE;
BEGIN
     ASSIGN(CREATE_HANDLE,FILENAME);
     REWRITE(CREATE_HANDLE,1);
     WITH CREATE_HEADER DO BEGIN
          FIELDCOUNT:=0;
          RECORDCOUNT:=0;
          RBASEID1:=1111;
          RBASEID2:='RYAN DATABASE';
          RECORDS[1]:=1;
     END;
END;
PROCEDURE ADDFIELD;
VAR I:INTEGER;
BEGIN
     WITH CREATE_HEADER DO BEGIN
          INC(FIELDCOUNT);
          I           :=FIELDCOUNT;
          FIELD[I]    :=UPPERCASE(FNAME);
          FIELDTYPE[I]:=UPCASE(FTYPE);
          FIELDLEN[I] :=FLEN;
          FIELDDEC[I] :=FDEC;
          CASE FTYPE OF
               'C'    :RECORDS[I+1]:=RECORDS[I]+FLEN+1;
               'L'    :RECORDS[I+1]:=RECORDS[I]+SIZEOF(LONGINT);
               'N','R','$':RECORDS[I+1]:=RECORDS[I]+SIZEOF(RREAL);
               'D'    :RECORDS[I+1]:=RECORDS[I]+SIZEOF(RDATE);
          END;
     END;

END;
PROCEDURE DONE;
BEGIN
     WITH CREATE_HEADER DO BEGIN
          RECORDLEN:=RECORDS[FIELDCOUNT+1];
     END;
     BLOCKWRITE(CREATE_HANDLE,CREATE_HEADER,SIZEOF(CREATE_HEADER));
     CLOSE(CREATE_HANDLE);
END;

PROCEDURE TRBASE.OPENDB;
BEGIN
     ASSIGN(DBHANDLE,FILENAME);
     RESET(DBHANDLE,1);
     OPENED:=FALSE;
     IF IORESULT<>0 THEN EXIT;
     BLOCKREAD(DBHANDLE,HEADER,SIZEOF(HEADER));
     FILTER:=FALSE;
     RECORDFOUND:=HEADER.RECORDCOUNT;
     GOTOP;
     INDEXS:=NIL;
     OPENED:=TRUE;
END;

PROCEDURE TRBASE.CLOSEDB;
BEGIN
     SEEK(DBHANDLE,0);
     BLOCKWRITE(DBHANDLE,HEADER,SIZEOF(HEADER));
     CLOSE(DBHANDLE);
     IF INDEXS<>NIL THEN DISPOSE(INDEXS);
END;

PROCEDURE TRBASE.READRECORD;
BEGIN
     IF I<0 THEN DBER:=DBE_NOTVALIDRECORD;
     SEEK(DBHANDLE,SIZEOF(HEADER)+I*HEADER.RECORDLEN);
     BLOCKREAD(DBHANDLE,BUFFER,HEADER.RECORDLEN);

END;
PROCEDURE TRBASE.WRITERECORD;
BEGIN
     IF I<0 THEN DBER:=DBE_NOTVALIDRECORD;
     SEEK(DBHANDLE,SIZEOF(HEADER)+I*HEADER.RECORDLEN);
     BLOCKWRITE(DBHANDLE,BUFFER,HEADER.RECORDLEN);
END;

PROCEDURE TRBASE.CLEARBUFFER;
BEGIN
     FILLCHAR(BUFFER,SIZEOF(BUFFER),0);
END;

FUNCTION TRBASE.FIELDNO;
VAR T:INTEGER;
BEGIN
     FIELDNO:=0;
     FNAME:=UPPERCASE(FNAME);
     FOR T:=1 TO HEADER.FIELDCOUNT DO
         IF FNAME=HEADER.FIELD[T] THEN BEGIN FIELDNO:=T;EXIT;END;
END;

FUNCTION TRBASE.FIELDGET;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     FIELDGET:='';
     NO:=FIELDNO(FNAME);
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     fieldget:=ra^;
     CASE HEADER.FIELDTYPE[NO] OF
          'C':FIELDGET:=RA^;
          'L':FIELDGET:=LONGINTTOSTR(RB^,HEADER.FIELDLEN[NO]);
          'N','R':FIELDGET:=REALTOSTR(RC^,HEADER.FIELDLEN[NO],HEADER.FIELDDEC[NO]);
          '$':FIELDGET:=RSTR.CURRTOSTR(RC^,HEADER.FIELDLEN[NO]);
          'D':FIELDGET:=DTOC(RD^);
     END;
END;
FUNCTION TRBASE.NUMBERGET;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     NUMBERGET:=0;
     NO:=FIELDNO(FNAME);
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[NO] OF
          'C':NUMBERGET:=0;
          'L':NUMBERGET:=RB^;
          'N','R':NUMBERGET:=RC^;
          '$':NUMBERGET:=RC^;
          'D':NUMBERGET:=RD^;
     END;
END;
FUNCTION TRBASE.LONGINTGET;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     LONGINTGET:=0;
     NO:=FIELDNO(FNAME);
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[NO] OF
          'C'          :LONGINTGET:=0;
          'L'          :LONGINTGET:=RB^;
          'N','R','$'  :LONGINTGET:=ROUND(RC^);
          'D'          :LONGINTGET:=RD^;
     END;
END;

FUNCTION TRBASE.FIELDNOGET;
VAR P:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     FIELDNOGET:='';
     IF FNAME=0 THEN EXIT;

     P:=HEADER.RECORDS[FNAME];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[FNAME] OF
          'C':FIELDNOGET:=RA^;
          'L':FIELDNOGET:=LONGINTTOSTR(RB^,HEADER.FIELDLEN[FNAME]);
          'N','R':FIELDNOGET:=REALTOSTR(RC^,HEADER.FIELDLEN[FNAME],HEADER.FIELDDEC[FNAME]);
          '$':FIELDNOGET:=RSTR.CURRTOSTR(RC^,HEADER.FIELDLEN[FNAME]);
          'D':FIELDNOGET:=DTOC(RD^);
     END;
END;

PROCEDURE TRBASE.FIELDPUT;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     NO:=FIELDNO(FNAME);
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[NO] OF
          'C':RA^:=CUTS(ITEM,HEADER.FIELDLEN[NO]);
          'L':RB^:=STRTOLONGINT(ITEM);
          'N','R','$':RC^:=STRTOREAL(ITEM);
          'D':RD^:=CTOD(ITEM);
     END;
END;

PROCEDURE TRBASE.NUMBERPUT;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     NO:=FIELDNO(FNAME);
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[NO] OF
          'C':RA^:=PREALTOSTR(ITEM);
          'L':RB^:=ROUND(ITEM);
          'N','R','$':RC^:=ITEM;
     END;
END;
PROCEDURE TRBASE.LONGINTPUT;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     NO:=FIELDNO(FNAME);
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[NO] OF
          'C':RA^:=PREALTOSTR(ITEM);
          'L','D':RB^:=ITEM;
          'N','R','$':RC^:=ITEM;
     END;
END;

PROCEDURE TRBASE.FIELDNOPUT;
VAR P,NO:INTEGER;
BEGIN
     DBER:=DBE_NOERROR;
     IF NO=0 THEN EXIT;

     P:=HEADER.RECORDS[NO];
     RA:=POINTER(DWORD(@BUFFER)+P);
     RB:=ptr(dword(RA));
     Rc:=ptr(dword(RA));
     Rd:=ptr(dword(RA));
     CASE HEADER.FIELDTYPE[NO] OF
          'C':RA^:=CUTS(ITEM,HEADER.FIELDLEN[NO]);
          'L':RB^:=STRTOLONGINT(ITEM);
          'N','R','$':RC^:=STRTOREAL(ITEM);
          'D':RD^:=CTOD(ITEM);
     END;
END;


PROCEDURE TRBASE.APPEND;
BEGIN
     DBER:=DBE_NOERROR;
     WRITERECORD(HEADER.RECORDCOUNT);
     INC(HEADER.RECORDCOUNT);
     IF NOT FILTER THEN RECORDFOUND:=HEADER.RECORDCOUNT ELSE
     BEGIN
        IF FILTERPROC THEN BEGIN
           SETINDEX(HEADER.RECORDCOUNT);
           INC(RECORDFOUND);
        END ELSE UNSETINDEX(HEADER.RECORDCOUNT);
     END;
END;

PROCEDURE TRBASE.REPLACE;
BEGIN
     DBER:=DBE_NOERROR;
     WRITERECORD(PHYSICREC-1);
     IF FILTER THEN BEGIN
        IF FILTERPROC THEN SETINDEX(PHYSICREC) ELSE
                           UNSETINDEX(PHYSICREC);
     END;
END;

PROCEDURE TRBASE.SETINDEX(N:LONGINT);
VAR NO,NI:WORD;
BEGIN
     NO:=N SHR 3;
     NI:=1 SHL (N AND 7);
     INDEXS^[NO]:=INDEXS^[NO] OR NI;
END;
PROCEDURE TRBASE.UNSETINDEX(N:LONGINT);
VAR NO,NI:WORD;
BEGIN
     NO:=N SHR 3;
     NI:=1 SHL (N AND 7);
     INDEXS^[NO]:=INDEXS^[NO] AND (NOT NI);
END;
FUNCTION TRBASE.ISINDEX(N:LONGINT):BOOLEAN;
VAR NO,NI:WORD;
BEGIN
     NO:=N SHR 3;
     NI:=1 SHL (N AND 7);
     ISINDEX:=(INDEXS^[NO] AND (NI)) <>0;
END;

PROCEDURE TRBASE.REFILTER;
VAR T,XX:LONGINT;
BEGIN
     IF NOT FILTER THEN EXIT;
     DBER:=DBE_NOERROR;
     IF INDEXS=NIL THEN NEW(INDEXS);
     XX:=0;
     FOR T:=1 TO HEADER.RECORDCOUNT DO
     BEGIN
          READRECORD(T-1);
          IF FILTERPROC THEN BEGIN
             SETINDEX(T);
             INC(XX);
          END
          ELSE UNSETINDEX(T);
     END;
     RECORDFOUND:=XX;
     GOTOP;
END;
PROCEDURE TRBASE.FILTERUSE(A:TFILTERPROC);
VAR T,XX:LONGINT;
BEGIN
     DBER:=DBE_NOERROR;
     IF INDEXS=NIL THEN NEW(INDEXS);
     FILTER:=TRUE;
     FILTERPROC:=A;
     XX:=0;
     GOTOP;
     FOR T:=1 TO HEADER.RECORDCOUNT DO
     BEGIN
          READRECORD(T-1);
          IF A THEN BEGIN
             SETINDEX(T);
             INC(XX);
          END
          ELSE UNSETINDEX(T);

     END;
     RECORDFOUND:=XX;
     GOTOP;
END;


PROCEDURE TRBASE.UNFILTER;
BEGIN
     DBER:=DBE_NOERROR;
     IF NOT FILTER THEN EXIT;
     FILTER:=FALSE;
     FILTERPROC:=FILTERDUMMY;
     RECORDFOUND:=HEADER.RECORDCOUNT;
     CURRENTREC:=PHYSICREC;
     IF INDEXS<>NIL THEN DISPOSE(INDEXS);
     INDEXS:=NIL;
END;

PROCEDURE TRBASE.PSKIP(I:LONGINT);
BEGIN
     DBER:=DBE_NOERROR;
     INC(CURRENTREC,I);
     IF CURRENTREC>HEADER.RECORDCOUNT THEN BEGIN
        CURRENTREC:=HEADER.RECORDCOUNT;
        DBER:=DBE_ENDOFRECORD;
     END;

     READRECORD(CURRENTREC-1);
     PHYSICREC:=CURRENTREC;
END;

PROCEDURE TRBASE.PGO(I:LONGINT);
BEGIN
     DBER:=DBE_NOERROR;
     CURRENTREC:=I;
     IF CURRENTREC>HEADER.RECORDCOUNT THEN BEGIN
        CURRENTREC:=HEADER.RECORDCOUNT;
        DBER:=DBE_ENDOFRECORD;
     END;
     READRECORD(CURRENTREC-1);
     PHYSICREC:=CURRENTREC;
END;

PROCEDURE TRBASE.IGO(I:LONGINT);
VAR N:LONGINT;
    CR,T:LONGINT;
BEGIN
     DBER:=DBE_NOERROR;
     N:=0;
     FOR T:=1 TO HEADER.RECORDCOUNT DO BEGIN
         IF ISINDEX(T) THEN BEGIN
            CR:=T;
            INC(N);
         END;
         IF N=I THEN BEGIN
            BREAK;
         END;
     END;
     IF N<>I THEN DBER:=DBE_ENDOFRECORD;
     CURRENTREC:=N;
     READRECORD(CR-1);
     PHYSICREC:=CR;
END;
PROCEDURE TRBASE.ISKIP(I:LONGINT);
BEGIN
     DBER:=DBE_NOERROR;
     INC(CURRENTREC,I);
     IGO(CURRENTREC);
END;

PROCEDURE TRBASE.GOTOP;
BEGIN
     DBER:=DBE_NOERROR;
     IF FILTER THEN IGO(1) ELSE PGO(1);
END;
PROCEDURE TRBASE.SKIP(I:LONGINT);
BEGIN
     IF FILTER THEN ISKIP(I) ELSE PSKIP(I);
END;
PROCEDURE TRBASE.GO(I:LONGINT);
BEGIN
     IF FILTER THEN IGO(I) ELSE PGO(I);
END;

PROCEDURE TRBASE.FIND(FIELD,WHAT:STRING);
VAR T,NO:LONGINT;
BEGIN
     FOUND:=FALSE;
     DBER:=DBE_NOERROR;
     NO:=FIELDNO(FIELD);
     GOTOP;
     IF RECORDFOUND>0 THEN
     FOR T:=1 TO RECORDFOUND DO BEGIN
         IF FIELDNOGET(NO)=WHAT THEN BEGIN
         FOUND:=TRUE;
         EXIT;
         END
         ELSE SKIP(1);
     END;
END;
     {$I+}

PROCEDURE REFRESHLOCAL;
BEGIN
END;

PROCEDURE SELECT(N:BYTE);
BEGIN
     DBSELECT:=N;
     DBACTIVE:=@DBOBJ[N];
     REFRESHLOCAL;
END;
PROCEDURE USE(N:STRING);
BEGIN
     WITH DBACTIVE^ DO BEGIN
          IF OPENED THEN CLOSEDB;
          FILENAME:=N;
          OPENDB;
     END;
     REFRESHLOCAL;
END;
PROCEDURE CLOSEDATABASES;
VAR T:INTEGER;
BEGIN
     FOR T:=0 TO 20 DO
     WITH DBOBJ[T] DO BEGIN
          IF OPENED THEN CLOSEDB;
     END;
END;
PROCEDURE FIND(N:STRING);
BEGIN
     DBACTIVE^.FIND(INDEX[DBSELECT],N);
END;
PROCEDURE SKIP(N:LONGINT);
BEGIN
     DBACTIVE^.SKIP(N);
END;
PROCEDURE GO(N:LONGINT);
BEGIN
     DBACTIVE^.GO(N);
END;
PROCEDURE SETFILTERTHRU(A:TFILTERPROC);
BEGIN
     DBACTIVE^.FILTERUSE(A);
END;
PROCEDURE GOTOP;
BEGIN
     DBACTIVE^.GOTOP;
END;
PROCEDURE UNFILTER;
BEGIN
     DBACTIVE^.UNFILTER;
END;
PROCEDURE INDEXON(A,N:STRING);
BEGIN
     INDEX[DBSELECT]:=N;
END;
PROCEDURE STRINGPUT(A,B:STRING);
BEGIN
     DBACTIVE^.FIELDPUT(A,B);
END;
FUNCTION FIELDGET(A:STRING):STRING;
BEGIN
     FIELDGET:=DBACTIVE^.FIELDGET(A);
END;
PROCEDURE NUMBERPUT(A:STRING;B:RREAL);
BEGIN
     DBACTIVE^.NUMBERPUT(A,B);
END;
FUNCTION NUMBERGET(A:STRING):RREAL;
BEGIN
     NUMBERGET:=DBACTIVE^.NUMBERGET(A);
END;
FUNCTION DEOF:BOOLEAN;
BEGIN
     DEOF:=(DBACTIVE^.DBER<>DBE_NOERROR);
END;

FUNCTION FIELD(I:INTEGER):STRING;
BEGIN
     FIELD:=DBACTIVE^.HEADER.FIELD[I];
END;
FUNCTION FIELDTYPE(I:INTEGER):CHAR;
BEGIN
     FIELDTYPE:=DBACTIVE^.HEADER.FIELDTYPE[I];
END;
FUNCTION FIELDLEN(I:INTEGER):BYTE;
BEGIN
     FIELDLEN:=DBACTIVE^.HEADER.FIELDLEN[I];
END;
FUNCTION FIELDDEC(I:INTEGER):BYTE;
BEGIN
     FIELDDEC:=DBACTIVE^.HEADER.FIELDDEC[I];
END;
FUNCTION FIELDCOUNT:INTEGER;
BEGIN
     FIELDCOUNT:=DBACTIVE^.HEADER.FIELDCOUNT;
END;
PROCEDURE CLEARRECORD;
BEGIN
     DBACTIVE^.CLEARBUFFER;
END;
PROCEDURE APPEND;
BEGIN
     DBACTIVE^.APPEND;
END;
PROCEDURE REPLACE;
BEGIN
     DBACTIVE^.REPLACE;
END;
FUNCTION RECORDFOUND:INTEGER;
BEGIN
     RECORDFOUND:=DBACTIVE^.RECORDFOUND;
END;
FUNCTION FOUND:BOOLEAN;
BEGIN
     FOUND:=DBACTIVE^.FOUND;
END;
FUNCTION FILEEXIST(N:STRING):BOOLEAN;
VAR F:FILE;
BEGIN
     ASSIGN(F,N);
     {$I-}
     RESET(F,1);
     {$I+}
     IF IORESULT=0 THEN BEGIN
        FILEEXIST:=TRUE;
        CLOSE(F);
     END ELSE FILEEXIST:=FALSE;

END;

PROCEDURE REFILTER;
BEGIN
     DBACTIVE^.REFILTER;
END;

FUNCTION DATEGET(A:STRING):LONGINT;
BEGIN
     DATEGET:=DBACTIVE^.LONGINTGET(A);
END;
PROCEDURE DATEPUT(A:STRING;B:LONGINT);
BEGIN
     DBACTIVE^.LONGINTPUT(A,B);
END;

VAR T:INTEGER;
BEGIN
     SELECT(0);
     FOR T:=0 TO 20 DO BEGIN
         INDEX[T]:='';
         DBOBJ[T].OPENED:=FALSE;
     END;
END.
